반응형
시간 제한 | 메모리 제한 | 제출 | 정답 | 맞은 사람 | 정답 비율 |
---|---|---|---|---|---|
1 초 | 256 MB | 22359 | 6915 | 3994 | 29.491% |
문제
전화번호 목록이 주어진다. 이때, 이 목록이 일관성이 있는지 없는지를 구하는 프로그램을 작성하시오.
전화번호 목록이 일관성을 유지하려면, 한 번호가 다른 번호의 접두어인 경우가 없어야 한다.
예를 들어, 전화번호 목록이 아래와 같은 경우를 생각해보자
- 긴급전화: 911
- 상근: 97 625 999
- 선영: 91 12 54 26
이 경우에 선영이에게 전화를 걸 수 있는 방법이 없다. 전화기를 들고 선영이 번호의 처음 세 자리를 누르는 순간 바로 긴급전화가 걸리기 때문이다. 따라서, 이 목록은 일관성이 없는 목록이다.
입력
첫째 줄에 테스트 케이스의 개수 t가 주어진다. (1 ≤ t ≤ 50) 각 테스트 케이스의 첫째 줄에는 전화번호의 수 n이 주어진다. (1 ≤ n ≤ 10000) 다음 n개의 줄에는 목록에 포함되어 있는 전화번호가 하나씩 주어진다. 전화번호의 길이는 길어야 10자리이며, 목록에 있는 두 전화번호가 같은 경우는 없다.
출력
각 테스트 케이스에 대해서, 일관성 있는 목록인 경우에는 YES, 아닌 경우에는 NO를 출력한다.
예제 입력 1
2
3
911
97625999
91125426
5
113
12340
123440
12345
98346
예제 출력 1
NO
YES
코드
/*
트라이 구현.
1. Map을 이용
2. 배열을 이용
두 가지 방법이 있는데 , 해당 문제에서는 Map을 이용하였다.
맨 아래에 배열을 이용한 풀이가 있다.
*/
import java.util.*;
import java.io.*;
public class p5052 {
static int t;
static Trie trie;
static class TrieNode {
Map<Character, TrieNode> childNodes;
boolean isLeapNode;
public TrieNode() {
childNodes = new HashMap<>();
}
}
static class Trie {
TrieNode rootNode;
public Trie() {
rootNode = new TrieNode();
}
void insert(String s) {
TrieNode thisNode = this.rootNode;
for (int i = 0; i < s.length(); i++) {
char c = s.charAt(i);
thisNode = thisNode.childNodes.computeIfAbsent(c, key -> new TrieNode());
}
thisNode.isLeapNode = true;
}
boolean find(String s) {
TrieNode thisNode = this.rootNode;
for (int i = 0; i < s.length(); i++) {
char c = s.charAt(i);
thisNode = thisNode.childNodes.get(c);
if (i != s.length() - 1 && thisNode.isLeapNode) {
return false;
}
}
return true;
}
}
public static void main(String[] args) throws IOException {
BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
t = Integer.parseInt(br.readLine());
while (t-- > 0) {
trie = new Trie();
int n = Integer.parseInt(br.readLine());
String[] arr = new String[n];
for (int i = 0; i < n; i++) {
arr[i] = br.readLine();
trie.insert(arr[i]);
}
boolean flag = true;
for (int i = 0; i < n; i++) {
if (!trie.find(arr[i])) {
flag = false;
}
}
if (flag) {
System.out.println("YES");
} else {
System.out.println("NO");
}
}
}
}
배열을 이용한 TRIE
import java.io.*;
import java.util.*;
public class Main {
static int T, N;
static boolean NO;
public static void main(String[] args) throws IOException {
BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
T = Integer.parseInt(br.readLine());
StringBuilder str = new StringBuilder();
while (T-- > 0) {
TrieTree trieTree = new TrieTree();
ArrayList<String> numbers = new ArrayList<>();
N = Integer.parseInt(br.readLine());
NO = false;
for (int i = 0; i < N; i++) {
String number = br.readLine();
numbers.add(number);
}
numbers.sort(Comparator.comparingInt(String::length));
for (String number : numbers) {
if (NO) continue;
trieTree.insert(number);
}
if (NO) str.append("NO").append("\n");
else str.append("YES").append("\n");
}
System.out.print(str);
}
private static class Tree
{
Tree[] next = new Tree[10];
boolean isEnd = false;
}
private static class TrieTree
{
Tree root = new Tree();
private void insert(String number)
{
Tree current = root;
for (int i = 0; i < number.length(); i++) {
if (current.next[number.charAt(i) - '0'] == null) {
current.next[number.charAt(i) - '0'] = new Tree();
} else if (current.next[number.charAt(i) - '0'].isEnd) {
NO = true;
break;
}
current = current.next[number.charAt(i) - '0'];
}
current.isEnd = true;
}
}
}
반응형
'알고리즘 > [ Baekjoon ]' 카테고리의 다른 글
[ BOJ ][JAVA][5545] 최고의 피자 (0) | 2021.04.25 |
---|---|
[ BOJ ][JAVA][5397] 키로거 (0) | 2021.04.25 |
[ BOJ ][JAVA][5014] 스타트링크 (0) | 2021.04.25 |
[ BOJ ][JAVA][4963] 섬의 개수 (0) | 2021.04.25 |
[ BOJ ][JAVA][4949] 균형잡힌 세상 (0) | 2021.04.25 |